#import "_PNArcP2T.h"

/**
 General purpose parent class at the level of PNNet, PNTransition, PNPlace,  PNArc, PNArcP2T, PNArcT2P, PNToken.
 PNArcP2T connects a PNPlace to a PNTransition.
 */
@interface PNArcP2T : _PNArcP2T {}


/**
    Removes all tokens from the receiver's upstream place that satisfy the guard expression, and returns them in a set.
	@returns all tokens from the receiver's upstream place that satisfy the guard expression.
 */
-(NSSet*)pullTokens;
/**
 Removes some unspecified token from the receiver's upstream place that satisfy the guard expression, and returns them in a set.
 @returns some unspecified token from the receiver's upstream place that satisfy the guard expression.
 */
-(PNToken*)pullToken;

/**
	For debugging: 
	@returns @"P_upstreamPlace -> T_downstreamTransition"
 */
-(NSString*)route;
@end
