#import "PNArcP2T.h"

#import "PNPlace.h"

#import "PNTransition.h"


@implementation PNArcP2T

// Custom logic goes here.

-(NSSet*)satisfactoryTokens
{
    NSSet *available = [self.inPlace availableTokens];
    
    NSMutableSet *satisfactoryTokens = [NSMutableSet setWithCapacity: available.count];
    
    for( PNToken *next in available ){
        if( [self satisfactoryToken: next] ){
            [satisfactoryTokens addObject: next];
        }
    }
    return satisfactoryTokens;
}

-(BOOL)hasSufficientTokens
{
    return ( self.multiplicityValue <= self.satisfactoryTokens.count );
}

-(PNToken *)pullToken
{
    NSSet *satisfactoryTokens = [self satisfactoryTokens];
    
    PNToken *haplessToken = [satisfactoryTokens anyObject];
    if( nil != haplessToken ){
        [self.inPlace removeToken: haplessToken];
    }
    return haplessToken;
}

-(NSSet*)pullTokens
{
    NSSet *satisfactoryTokens = [self satisfactoryTokens];
    
    for( PNToken *t in satisfactoryTokens ){
        [self.inPlace removeToken: t];
    }
    return satisfactoryTokens;
}

-(NSString*)route
{
    NSString *route = [NSString stringWithFormat: @"P_%@ -> T_%@",
                       self.inPlace.name,
                       self.outTransition.name];
    return route;
}
@end
