#import "_PNArcT2P.h"

/**
 General purpose parent class at the level of PNNet, PNTransition, PNPlace,  PNArc, PNArcP2T, PNArcT2P, PNToken.
 PNArcT2P connects a PNTransition to a PNPlace.
 */
@interface PNArcT2P : _PNArcT2P {}
// Custom logic goes here.


/**
 A filter for incoming tokens.
 @param tokensIn a set of tokens.
 @returns any tokens from tokensIn that satify the receiver's guard expression.
 */
-(NSSet*)satisfactoryTokens: (NSSet*)tokensIn;

/**
	Tests each token in tokens against the receiver's guard expression, and adds satisfactory tokens to the receiver's downstream place.
 */
-(void)pushTokens: (NSSet*)tokens;

/**
 -pushToken: does not test on the token's uuid.
 It tests only on the token's class.
 
 If you push an individual token explicitly,
 there's no need to access the arc's uuids first.
 
 */
-(void)pushToken: (PNToken*)singleToken;

/**
 For debugging:
 @returns @"-> T_upstreamTransition -> P_downstreamPlace"
 */

-(NSString*)route;
@end
