#import "PNArcT2P.h"

#import "PNPlace.h"

#import "PNArc.h"

#import "PNTransition.h"

#import "PNToken.h"

@implementation PNArcT2P

// Custom logic goes here.
-(NSSet*)satisfactoryTokens: (NSSet*)tokensIn
{
    
    NSMutableSet *tokensOut = [NSMutableSet setWithCapacity: tokensIn.count];
    
    for( PNToken *next in tokensIn ){
        if( [self satisfactoryToken: next] ){
            [tokensOut addObject: next];
        }
    }
    return tokensOut;
}

-(void)pushTokens: (NSSet*)tokens
{
    NSSet *satisfactoryTokens = [self satisfactoryTokens: tokens];

    for( PNToken *t in satisfactoryTokens ){
        [self.outPlace addToken: t];
    }    
 }

-(void)pushToken: (PNToken*)singleToken
{
    if( [singleToken.entity.name isEqualToString: self.targetTokenEntityName] ){
        [self.outPlace addToken: singleToken];
    }
}

-(NSString*)route
{
    NSString *route = [NSString stringWithFormat: @"T_%@ -> P_%@",
                       self.inTransition.name,
                       self.outPlace.name];
    return route;
}

@end
