//
//  PNDocSupportNetController+CoreDataManaging.h
//  TaggedLocationsDemo
//
//  Created by DevGuy on 11/6/12.
//
//

#import "PNDocSupportNetController.h"

#import <CoreData/CoreData.h>

/**
	The CoreDataManaging category simply encapsulates the methods that build the Core Data "stack."

 */
@interface PNDocSupportNetController (CoreDataManaging)

@property (readonly, strong, nonatomic) NSManagedObjectContext *managedObjectContext;
@property (readonly, strong, nonatomic) NSManagedObjectModel *managedObjectModel;
@property (readonly, strong, nonatomic) NSPersistentStoreCoordinator *persistentStoreCoordinator;

/**
	Builds the core data stack: A call to [self.managedObjectContext saveAnyChanges] lazily instantiates _managedObjectContext, which lazily instantiates _persistentStoreCoordinator, which lazily instantiates _managedObjectModel. This core data stack supports PNDocSupportNet—its places, transitions, arcs, and tokens. This core data stack does not interact with any UIManagedDocument's core data stack.
 */
-(void)buildCoreDataStack;

@end
