//
//  PNDocSupportNetController+PipelineTransitionFiring.m
//  TaggedLocationsDemo
//
//  Created by DevGuy on 12/5/12.
//
//

#import "PNDocSupportNetController+PipelineTransitionFiring.h"

#import "PNDocSupportNet.h"
#import "PNDocToken.h"

#import "PNCloseCreate.h"
#import "PNCloseOpen.h"

#import "PNRenameDoc.h"

#import "PNCloseFlipOpen.h"

@implementation PNDocSupportNetController (PipelineTransitionFiring)
#pragma mark PNCloseCreate:
-(void)      closeDocToken: (PNDocToken*)haplessDocToken
                 fromPlace: (PNDocTokenPlace*)sourcePlace
createDocWithLocalizedName: (NSString*)aLocalizedName
         documentClassName: (NSString*)documentClassName
         midPathComponents: (NSArray*)aMidPath
          creationDelegate: (id <PNDocumentCreating>)creationDelegate
                   toPlace: (PNDocTokenPlace*)destPlace
                    sender: (id <PNTransitionDelegate>)sender
{
    [self.docSupportNet.closeCreateDoc enableFor: sender
                                  closeUuid: haplessDocToken.uuid
                                  fromPlace: sourcePlace
                      documentLocalizedName: aLocalizedName
                          documentClassName: documentClassName
                                    midPathComponents: aMidPath
                           creationDelegate: creationDelegate
                                    toPlace: destPlace];
}
#pragma mark PNCloseOpen
-(void)closeDocToken: (PNDocToken*)haplessDocToken
           fromPlace: (PNDocTokenPlace*)fromPlace
     openDocWithUUID: (NSString*)uuidToOpen
             toPlace: (PNDocTokenPlace*)toPlace
              sender: (id <PNTransitionDelegate>)sender
{
    [self.docSupportNet.closeOpenDoc enableFor: sender
                                closeUuid: haplessDocToken.uuid
                                fromPlace: fromPlace
                                 openUuid: (NSString*)uuidToOpen
                                  toPlace: toPlace];

}

#pragma mark PNCloseFlipOpen
/*
 -(void)enableFor:  (id<PNTransitionDelegate>)aPipelineTransitionDelegate
 toCloud: (BOOL)flag
 targetUuid: (NSString*)targetUuid
 fromPlace: (PNDocTokenPlace*)fromPlace
 toPlace: (PNDocTokenPlace*)toPlace;
 
 */
-(void)flipDocToken: (PNDocToken*)haplessDocToken
              place: (PNDocTokenPlace*)place
            toCloud: (BOOL)flag
             sender: (id <PNTransitionDelegate>)sender
{
    [self.docSupportNet.closeFlipOpenDoc enableFor: sender
                                           toCloud: flag
                                        targetUuid: haplessDocToken.uuid
                                         fromPlace:place
                                           toPlace:place];
    
}

@end
