//
//  PNDocSupportNetController+TransitionFiring.m
//  TaggedLocationsDemo
//
//  Created by DevGuy on 11/2/12.
//
//

#import "PNDocSupportNetController+TransitionFiring.h"

#import "PNURLToken.h"
#import "PNDocToken.h"
#import "PNDocTokenPlace.h"
#import "PNTransitionDelegate.h"

//#import "PNDocTokenTransition.h"
#import "PNURLTokensTransition.h"

#import "PNDeleteUUIDs.h"

#import "PNCreateDoc.h"
#import "PNOpenDoc.h"
#import "PNCloseDoc.h"
#import "PNDocSupportNet.h"

#import "PNDeleteUUIDs.h"

#import "PNRenameDoc.h"

@implementation PNDocSupportNetController (TransitionFiring)

#pragma mark PNDeleteUUIDs
-(void)deleteURLsWithUuids: (NSSet*)uuids
                    sender: (id <PNTransitionDelegate>)sender
{
    [self.docSupportNet.deleteUUIDs enableFor: sender
                                  targetUuids: uuids];
}


#pragma mark PNCreateDoc
-(void)createDocWithLocalizedName: (NSString*)aLocalizedName
                documentClassName: (NSString*)documentClassName
                midPathComponents: (NSArray*)aMidPath
                 creationDelegate: (id <PNDocumentCreating>)creationDelegate
                          toPlace: (PNDocTokenPlace*)toPlace
                           sender: (id <PNTransitionDelegate>)sender
{
    [self.docSupportNet.createDoc enableFor: sender
                      documentLocalizedName: aLocalizedName
                          documentClassName: documentClassName
                          midPathComponents: aMidPath
                           creationDelegate: creationDelegate
                                    toPlace: toPlace];

}

#pragma mark PNOpenDoc
-(void)openDocWithUUID: (NSString*)uuid
               toPlace: (PNDocTokenPlace*)toPlace
                sender: (id <PNTransitionDelegate>)sender
{
    [self.docSupportNet.openDoc enableFor: sender
                                     uuid: uuid
                                  toPlace: toPlace];
}

//#pragma mark PNCloseDoc
-(void)closeDocToken: (PNDocToken*)docToken
           fromPlace: (PNDocTokenPlace*)place
              sender: (id <PNTransitionDelegate>)sender
{
    return;
}


-(void)renameDocToken: (PNDocToken*)docToken
              newName: (NSString*)newName
            fromPlace: (PNDocTokenPlace*)sourcePlace
              toPlace: (PNDocTokenPlace*)destPlace
       deleteOriginal: (BOOL)deleteOriginalFlag
               sender: (id <PNTransitionDelegate>)sender
{
    
    
    [self.docSupportNet.renameDoc enableFor: sender
                               existingUuid: docToken.uuid
                                   renameTo: newName
                                  fromPlace: sourcePlace
                                    toPlace: destPlace
                             deleteOriginal: deleteOriginalFlag];

    return;
}

@end
