//
//  DocSupportNetController.m
//  TaggedLocationsDemo
//
//  Created by DevGuy on 10/31/12.
//
//

#import "PNDocSupportNetController.h"
#import "PNDocSupportNetController+CoreDataManaging.h"

#import "PNDocSupportNetController+StorageControlling.h"

#import "PNDocSupportNet.h"

#import "PNDocTokenPlace.h"
#import "NSManagedObject+PNPermanentIDing.h"

#import <UIKit/UIKit.h>

#import "PNURLToken.h"
#import "PNCloudURLToken.h"

#import "PNAlertViewHelper.h"

#import "NSURL+NPAssisting.h"

#import "PNSyncResources.h"
#import "PNQueryUpdate.h"

NSString* PNDocSupportNetControllerCloudAvailabilityDidChange = @"PNDocSupportNetControllerCloudAvailabilityDidChange";


@interface PNDocSupportNetController ()
@property (readwrite, strong) NSString *ubiquityContainerIdentifier;

@end

@implementation PNDocSupportNetController
CWL_SYNTHESIZE_SINGLETON_FOR_CLASS(PNDocSupportNetController);

@synthesize oneShotCloudStorageCallback;

@dynamic notificationObservers;

@dynamic docSupportNet;// = m_docSupportNet;

@dynamic userDefaults;
@dynamic threadSafeFileManager;

@synthesize appLevelTransitionDelegate;

@synthesize cloudContainer = m_cloudContainer;

@synthesize ubiquityContainerIdentifier = m_ubiquityContainerIdentifier;

-(NSMutableArray*)notificationbservers
{
    if( nil == m_notificationObservers ){
        m_notificationObservers = [[NSMutableArray alloc] initWithCapacity: 4];
    }
    return m_notificationObservers;
}
-(void)removeAllNotificationObservers
{
    NSNotificationCenter *dfC = [NSNotificationCenter defaultCenter];
    
    for( id observer in self.notificationObservers ){
        [dfC removeObserver: observer];
    }
    [self.notificationObservers removeAllObjects];
}

-(NSUserDefaults*)userDefaults
{
    return [NSUserDefaults standardUserDefaults];
}


+(PNDocSupportNetController*)sharedDocSupportNetController
{
    PNDocSupportNetController *dscn = [self sharedPNDocSupportNetController];
    return dscn;
}
-(void)appDidEnterBackground
{
    
}
-(void)appDidBecomeActive
{
    
}
-(void)appWillTerminate
{
    
}
-(void)observeSharedApp
{
    UIApplication *sharedApp = [UIApplication sharedApplication];
    
    NSNotificationCenter *dfc = [NSNotificationCenter defaultCenter];
    id observer =
    [dfc addObserverForName: UIApplicationDidEnterBackgroundNotification
                     object: sharedApp
                      queue: [NSOperationQueue mainQueue]
                 usingBlock: ^(NSNotification __strong *notification)
     {
         [self appDidEnterBackground];
     }];
    [self.notificationObservers addObject: observer];
    
    observer =
    [dfc addObserverForName: UIApplicationDidBecomeActiveNotification
                     object: sharedApp
                      queue: [NSOperationQueue mainQueue]
                 usingBlock: ^(NSNotification __strong *notification)
     {
         [self appDidBecomeActive];
     }];
    [self.notificationObservers addObject: observer];
    
    observer =
    [dfc addObserverForName: UIApplicationWillTerminateNotification
                     object: sharedApp
                      queue: [NSOperationQueue mainQueue]
                 usingBlock: ^(NSNotification __strong *notification)
     {
         [self appWillTerminate];
     }];
    [self.notificationObservers addObject: observer];
    
}

-(void)buildCoreDataStackInDirectory: (NSURL*)persistentStoreDirectory
          appLevelTransitionDelegate: (id <PNTransitionDelegate>)delegate
{
    NSAssert( (nil == _persistentStoreDirectory),
             @"-buildCoreDataStackInPersistentStoreDirectory: is a one-shot method.");
    
    _persistentStoreDirectory = persistentStoreDirectory;
    self.appLevelTransitionDelegate = delegate;
    
    {
        // In this passage, we clear out any contents of the persistent store directory.
        // One everything works as expected, we might try to
        // preserve the doc support net and its graph of objects.
        
        self.mostRecentUbiquityIdentityToken = nil; // Used in the StorageControlling category.
        // If we're starting fresh each time, we must set it to nil.
        
        NSArray *propertyKeys = [NSArray array];
        NSFileManager *fMgr = [[self class] threadSafeFileManager];
        
        NSDirectoryEnumerator *dirEnumerator = [fMgr enumeratorAtURL:persistentStoreDirectory
                                          includingPropertiesForKeys: propertyKeys
                                                             options: NSDirectoryEnumerationSkipsSubdirectoryDescendants
                                                        errorHandler: nil];
        for (NSURL *nextURL in dirEnumerator) {
            [fMgr removeItemAtURL: nextURL
                            error: nil];
        }

    }

    
    [self buildCoreDataStack];
    [self observeSharedApp];
        

    NSLog( @"PNDocSupportNet = %@", [self.docSupportNet description]);
}


+(NSFileManager*)threadSafeFileManager
{
    static NSFileManager *mm_fileManager = nil;
    if( nil == mm_fileManager ){
        mm_fileManager = [[NSFileManager alloc] init];
    }
    return mm_fileManager;
}
-(NSMutableArray*)notificationObservers
{
    if( nil == m_notificationObservers ){
        m_notificationObservers = [[NSMutableArray alloc] initWithCapacity: 16];
    }
    return m_notificationObservers;
}

-(NSFileManager*)threadSafeFileManager
{
    return [[self class] threadSafeFileManager];
}


-(PNDocSupportNet *)docSupportNet
{
    PNDocSupportNet *dsn = nil;
    if( nil == m_permID_docSupportNet ){
        NSManagedObjectContext *moc = self.managedObjectContext;
        dsn = [PNDocSupportNet insertInManagedObjectContext:moc];
        {
            // No explicit initialization up front.
            // All PNDocSupportNet's properties instantiate lazily.
        }
        [self.managedObjectContext saveAnyChanges];
        
        m_permID_docSupportNet = [dsn permanentID];
    }
    dsn = (PNDocSupportNet*)[self.managedObjectContext managedObjectForPermanentID: m_permID_docSupportNet];
    return dsn;
}

+(BOOL)guaranteeDirectoryAtURL: (NSURL*)url
{
    NSFileManager __block *fileMgr = [self threadSafeFileManager];
    
    NSError __block *error = nil;
    BOOL __block pathExists = NO;
    BOOL __block isDirectory = NO;
    
    NSFileCoordinator* coordinator =
    [[NSFileCoordinator alloc] initWithFilePresenter:nil];
    [coordinator coordinateReadingItemAtURL:url
                                    options:NSFileCoordinatorReadingWithoutChanges // ?? Correct choice?
                                      error: &error
                                 byAccessor:^(NSURL *coordinatedURL) {
                                     
                                     
                                     pathExists =
                                     [fileMgr fileExistsAtPath: coordinatedURL.path
                                                   isDirectory: &isDirectory];
                                 }];
    
    BOOL alreadyExists = (nil != error) && pathExists && isDirectory;
    
    if(alreadyExists){
        return YES;
    }else{
        
        BOOL __block didCreate = NO;
        [coordinator coordinateWritingItemAtURL:url
                                        options:NSFileCoordinatorWritingForMerging // ?? Correct choice?
                                          error: &error
                                     byAccessor:^(NSURL *coordinatedURL) {
                                         
                                         
                                         didCreate = [fileMgr createDirectoryAtPath: coordinatedURL.path
                                                        withIntermediateDirectories: YES
                                                                         attributes: nil
                                                                              error: &error ];
                                     }];
        
        if( !didCreate ){
            NSLog( @" Can't create directory: %@", [url absoluteString] );
        }
        NSAssert( didCreate, @" Can't create directory: %@", [url absoluteString] );
        
        return didCreate;        
    }
}

+(BOOL)guaranteeFileAtURL: (NSURL*)url
{
    NSURL *dir = [url URLByDeletingLastPathComponent];
    
    BOOL dirOK = [self guaranteeDirectoryAtURL: dir];
    if( !dirOK ){
        // Already croaked in -guaranteeDirectoryAtURL:, but:
        NSLog( @" Can't create containing directory: %@", [dir absoluteString] );
    }
    NSAssert( dirOK, @" Can't create file: %@", [dir absoluteString] );
    
    NSFileManager *fileMgr = [self threadSafeFileManager];
    
        
    NSError __block *error = nil;
    BOOL __block ok = NO;
    
    NSFileCoordinator* coordinator =
    [[NSFileCoordinator alloc] initWithFilePresenter:nil];
    [coordinator coordinateReadingItemAtURL:url
                                    options:NSFileCoordinatorWritingForMerging // ?? Correct choice?
                                      error: &error
                                 byAccessor:^(NSURL *coordinatedURL) {
                                     
                                     ok = [fileMgr createFileAtPath: [coordinatedURL path]
                                                           contents: nil
                                                         attributes: nil];
                                 }];

    
    if( !ok ){
        NSLog( @" Can't create file: %@", [url absoluteString] );
    }
    NSAssert( ok, @" Can't create file: %@", [url absoluteString] );
    
    return ok;
}

@end
