#import "_PNDocTokenPlace.h"

#import "PNDocTokenMarking.h"

/**
	Adds the marker property; every PNDocTokenPlace has a delegate that implements the PNDocTokenMarking protocol. 
 
 Typically, any of the adopting developer's custom view controllers that display documents each owns an instance of PNDocTokenPlace. The custom view controller might implement the PNDocTokenMarking protocol and set itself as its place's marker delegate.
 */
@interface PNDocTokenPlace : _PNDocTokenPlace
{
    id <PNDocTokenMarking> m_marker;
}

/**
	The marker delegate.
 */
@property (readwrite, strong) id <PNDocTokenMarking> marker;

@end
