#import "PNURLTokenPlace.h"

#import "PNURLToken.h"

@implementation PNURLTokenPlace

@synthesize uuidStatus;

// Custom logic goes here.


-(void)addToken: (PNToken*)token
{
    [super addToken: token];
    token.isAvailableValue = YES; //PNURLTokens in a PNURLTokenPlace must be available.
}

-(NSDictionary*)mapUuidsToAvailableTokens
{
    NSSet *available = [self availableTokens];
    
    NSMutableDictionary *result = [NSMutableDictionary dictionaryWithCapacity: available.count];
    
    for( PNURLToken* next in available ){
        [result setObject: next
                   forKey: next.uuid];
    }
    return result;
    
}
-(PNURLToken*)tokenForUuid: (NSString*)uuid
{
    NSDictionary *map = [self mapUuidsToAvailableTokens];
    
    return [map objectForKey: uuid];
}

-(NSSet*)tokensForUuids: (NSSet*)uuids
{
    NSDictionary *map = [self mapUuidsToAvailableTokens];
    NSMutableSet *result = [NSMutableSet setWithCapacity: map.count];
    
    for( NSString *next in uuids ){
        PNURLToken *t = [map objectForKey: next];
        if( nil != t ){
            [result addObject: t];
        }
    }
    return result;
}
@end
