//
//  PNDocTokenMarking.h
//  TaggedLocationsDemo
//
//  Created by Don Briggs on 7/3/12.
//  Copyright (c) 2012 Directed Graph Software LLC (AB). All rights reserved.
//

#import <Foundation/Foundation.h>

@class PNDocToken; 

// PNDocTokenPlace implements this protocol.

/**
 Set of methods to be implemented to act as the marker delegate of a PNDocTokenPlace. A marker delegate receives messages to signal a change in the presence of the token in the place, and when the doc token becomes available. It also handles any failures of internal operations of the doc token.
 */
@protocol PNDocTokenMarking //<NSObject>

#pragma mark Availability, called on the Main Thread
-(void)docTokenDidBecomeAvailable: (PNDocToken*)aDocToken;
-(void) docToken: (PNDocToken*)aDocToken
didFailWithError: (NSError*)error;

-(void)didAddDocToken: (PNDocToken*)token;
-(void)willRemoveDocToken: (PNDocToken*)token;
@end
