#import "_PNCloudURLToken.h"

/**
	PNCloudURLToken adds to PNURLToken support for its document's persistent store options and metadata.
 */
@interface PNCloudURLToken : _PNCloudURLToken
{
    NSMetadataItem *m_metadataItem;
    
    NSDictionary *m_persistentStoreOptions;
    
    NSURL *m_changeLogsURL;
    NSURL *m_cloudFilePackageURL;
}
/**
 From NSMetadataQuery. See -insertCloudURLTokenWithMetadataItem:inManagedObjectContext:
 */
@property (readwrite, strong) NSMetadataItem *metadataItem;

/**
	Returns the dictionary stored in self.metadataItem.
 */
@property (readonly, strong) NSDictionary *metadata;

/**
	Returns the uuid path component. This is a convenience method intended for clarity.
 */
@property (readonly, strong) NSDictionary *ubiquitousContentName;

@property (readonly, strong) NSURL *changeLogsURL;
@property (readonly, strong) NSURL *cloudFilePackageURL;

+(NSURL*)containerUrl;
+(NSURL*)changeLogsContainerUrl;

-(BOOL)setUbiquitous: (BOOL)flag
               error: (NSError**)error;
@end
