//
//  PNDocToken+FileOperations.h
//  TaggedLocationsDemo
//
//  Created by Don Briggs on 6/22/12.
//  Copyright (c) 2012 Directed Graph Software LLC (AB). All rights reserved.
//

#import "PNDocToken.h"


/**
	The PNDocToken (SimpleFileOperations) category provides methods that wrap for UIManagedDocument file operations and manage the attendant callbacks.
 
 See also the UIManagedDocument (PNDocTokenCallbackSupporting) and PNDocToken (CallbackSupporting) categories.

 */
@interface PNDocToken (SimpleFileOperations)

-(void)saveDocumentForCreating;
-(void)saveDocumentForOverwriting;

-(void)saveDocumentForRenaming;

-(void)revert;
-(void)closeDocument;
-(void)closeDocumentInBackgroundTask;

@end

@interface PNDocToken (AggregateFileOperations)

-(void)createAndSaveDocument;
-(void)createAndSaveDocumentPipelined;

-(void)establishDocument;
-(void)establishDocumentPipelined;

@end

