//
//  PNDocToken+LifeCycling.h
//  TaggedLocationsDemo
//
//  Created by DevGuy on 12/14/12.
//
//

#import "PNDocToken.h"

#import "PNDocumentCreating.h"


@class PNURLToken;

/**
 
 The methods of the PNDocToken (LifeCycling) category
 should be called only from -[PNDocToken transform] methods.
 
 The +docTokenWithURLToken:creationDelegate:   method should be called only after its operand url token has been removed from its place.
 
 (Typically, the url token is removed from one of the four primary places:
 {unassigned, assiged} x {local, cloud}).
 
 The +deleteDocToken: method should be called after the docToken has been removed from its place, and after setting its url token to nil.
 */

@interface PNDocToken (LifeCycling)
+(PNDocToken*)docTokenWithURLToken: (PNURLToken*)aUrlToken
                  creationDelegate: (id <PNDocumentCreating>) aCreationDelegate;

+(void)deleteDocToken: (PNDocToken*)haplessDocToken;

@end
