//
//  PNDocToken+LifeCycling.m
//  TaggedLocationsDemo
//
//  Created by DevGuy on 12/14/12.
//
//

#import "PNDocToken+LifeCycling.h"

#import "PNURLToken.h"

@implementation PNDocToken (LifeCycling)


+(PNDocToken*)docTokenWithURLToken: (PNURLToken*)aUrlToken
                  creationDelegate: (id <PNDocumentCreating>) aCreationDelegate
{
    // Defensive programming:
    NSAssert( (nil != aUrlToken), @"nil token.");
    NSAssert( ([aUrlToken isKindOfClass:[PNURLToken class]]),
             @"Bogus token of class %@",
             NSStringFromClass([aUrlToken class]) );
    
    NSManagedObjectContext *moc = aUrlToken.managedObjectContext;
    NSAssert( (nil != moc), @"Failed to get moc.");
    
    // The substantial consideration:
    NSAssert( (nil == aUrlToken.place),
             @"Some place still holds this token.");
    
    PNDocToken *result = [PNDocToken insertInManagedObjectContext:moc];
    result.urlToken = aUrlToken;
    result.creationDelegate = aCreationDelegate;
    
    return result;
}


+(void)deleteDocToken: (PNDocToken*)haplessDocToken
{
    // Defensive programming:
    NSAssert( (nil != haplessDocToken), @"nil token.");
    NSAssert( ([haplessDocToken isKindOfClass:[PNDocToken class]]),
             @"Bogus token of class %@",
             NSStringFromClass([haplessDocToken class]) );
    NSManagedObjectContext *moc = haplessDocToken.managedObjectContext;
    NSAssert( (nil != moc), @"Failed to get moc.");
    
    // The substantial consideration:
    NSAssert( (nil == haplessDocToken.urlToken),
             @"doc token still holds a  url token.");
    
    [moc deleteObject: haplessDocToken];
}

@end
