#import "PNDocToken.h"


#import "PNURLToken.h"
#import "PNDocTokenPlace.h"

#import "PNCloudURLToken.h"

#import "PNPlace.h"
#import "PNDocTokenPlace.h"

#import "NSManagedObject+PNPermanentIDing.h"

// #import <PNDocSupport/PNUuidStatus.h>


@implementation PNDocToken
// Custom logic goes here.

@dynamic documentReadable, documentWriteable;

@synthesize document = m_document;
@synthesize bkgTaskID = m_bkgTaskID;
@synthesize creationDelegate;

@dynamic log;

@dynamic queueLog;

@synthesize urlToken = m_urlToken;

//@dynamic filePackageURL;

@synthesize operationQueue = m_operationQueue;

//@synthesize rollbackDocState, rollbackUrl, rollbackUrlDeployment, rollbackUuidStatus;

//@synthesize didRollback = m_readyToRollback;

@synthesize error = m_error;

// Used only in FileOperations:
@dynamic onceAndFuturePlace;
@synthesize savedPlacePermanentID;

//-(void)setPlace:(PNPlace *)place
//{
//    // This method assures a match between the token and the place.
//    // See also -[PNURLToken setPlace:]
//    NSAssert( [place isKindOfClass: [PNDocTokenPlace class]],
//             @"-[PNDocToken -setPlace: requires PNDocTokenPlace");
////    [super setPlace: place];
//    super.place = place;
//}

-(PNDocTokenPlace*)onceAndFuturePlace
{
    NSManagedObjectContext *moc = self.managedObjectContext;
    
    PNDocTokenPlace *result =
    (PNDocTokenPlace*)[moc managedObjectForPermanentID: self.savedPlacePermanentID];
    return result; 
}
-(void)setOnceAndFuturePlace:(PNDocTokenPlace *)mySavedPlace
{
    self.savedPlacePermanentID = [mySavedPlace permanentID];
}
//-(NSURL*)filePackageURL
//{
//    return self.urlToken.localFilePackageURL;
//}

-(NSMutableString*)queueLog
{
    if( nil == m_queueLog ){
        m_queueLog = [[NSMutableString alloc] initWithCapacity: 128];
    }
    return m_queueLog;
}
-(NSString*)log
{
    return [self.queueLog copy];
}
-(NSOperationQueue*)operationQueue
{
    // Use lazy instantiation for the operationQueue.
    // We don't need it immediately.
    // We need it for file operations, e.g. establish, open, save, revert, close.
    
    if( nil == m_operationQueue ){
        m_operationQueue = [[NSOperationQueue alloc] init];
        m_operationQueue.maxConcurrentOperationCount = 1;
    }
    return m_operationQueue;
}


-(NSString*)uuid
{
    return self.urlToken.uuid;
}
-(NSDate*)date
{
    if( UIDocumentStateNormal == self.document.documentState ){
        return self.document.fileModificationDate;
    }else{
        return self.urlToken.date;
    }
}
//-(BOOL)cloudPersistent
//{
//    return [(self.urlToken) isKindOfClass: [PNCloudURLToken class]];
//}
-(NSString*)quickLook
{
    NSMutableString *result = [NSMutableString stringWithCapacity: 128];
    [result appendFormat: @"(%@*) " ,
     NSStringFromClass([self class]) ];
    
    if( nil == self.urlToken ){
        [result appendString: @"<nil urlToken>"];
    }else{
        [result appendString: [self.urlToken quickLook]];
    }

    if( nil == self.document ){
        [result appendString: @" [nil document]"];
    }else{
        [result appendFormat: @" [%@]", [self documentStateAsString]];
    }
    
    return result;
}

-(enum PNUuidStatus)uuidStatus
{
    return self.urlToken.uuidStatus;
}
#pragma mark Other:
-(BOOL)documentReadable
{
    BOOL result =
    (nil != self.document.managedObjectContext.persistentStoreCoordinator);
    return result;
}
-(BOOL)documentWriteable
{
    BOOL result =
    self.isAvailable &&
    self.documentReadable &&
    (UIDocumentStateNormal == self.document.documentState);
    return result;
}
//-(NSURL*)persistentStoreDbURL
//{
//    NSURL *step0 = [self.urlToken filePackageURL];
//    NSURL *step1 = [step0 URLByAppendingPathComponent:@"StoreContent"
//                                          isDirectory: YES];
//    
//    // When we migrate a persistent store,
//    // the transform token calls this method on the
//    // destination/final token BEFORE its document instantiates.
//    Class x = NSClassFromString( self.urlToken.documentClassName );
//    if( nil == x ){
//        x = [self.document class];
//    }
//    NSString *persistentStoreName = [x persistentStoreName];
//    NSURL *step2 = [step1 URLByAppendingPathComponent:persistentStoreName];
//    
//    return step2;
//}

#pragma mark In theory, theory and practice are the same.
#pragma mark In practice, they're different.

-(void)logRegisteredObjects
{
    NSSet *r = self.document.managedObjectContext.registeredObjects;
    NSLog(@"logRegisteredObjects = \n%@", [r description]);
}


-(NSString *) documentStateAsString
{
    NSUInteger state = self.document.documentState;
    
    // It seems unfortunate that UIManagedDocumentStateNormal == 0.
    // 0 == [<nil> documentState];
    if (UIDocumentStateNormal == state) return @"Normal";
    
    NSMutableArray *stateBits = [NSMutableArray arrayWithCapacity: 4];
    if ((state & UIDocumentStateClosed) != 0)
        [stateBits addObject:@"Closed"];
    if ((state & UIDocumentStateInConflict) != 0)
        [stateBits addObject:@"Conflict"];
    if ((state & UIDocumentStateSavingError) != 0)
        [stateBits addObject:@"Saving Error"];
    if ((state & UIDocumentStateEditingDisabled) != 0)
        [stateBits addObject:@"Editing Disabled" ];
    
    NSString *result = [stateBits componentsJoinedByString: @"|"];
    return result;
    
}

//
//-(PNPlace*)place
//{
//    return [super place];
//}
//-(void)setPlace: (PNPlace*)aPlace
//{
//    [super setPlace: aPlace];
//}
@end
