//
//  PNURLToken+LifeCycling.h
//  TaggedLocationsDemo
//
//  Created by DevGuy on 12/14/12.
//
//

#import "PNURLToken.h"
extern const NSString *PNDocMDataDotPlistKey;

@class PNCloudURLToken;

/**
 The methods of the PNURLToken (LifeCycling) category 
 should be called only from -[PNDocToken transform] methods.
 
 The +delete:error: and +promote:error: and methods should be called 
 only after their operand tokens have been removed from 
 their places.
 (Typically, they're removed from one of the four primary places:
    {unassigned, assiged} x {local, cloud}).
 */

@interface PNURLToken (LifeCycling)

+(PNURLToken*)insertLocalURLTokenWithProperties: (NSDictionary*)properties
                         inManagedObjectContext: (NSManagedObjectContext*) moc;

+(PNCloudURLToken*)insertCloudURLTokenWithProperties: (NSDictionary*)properties
                              inManagedObjectContext: (NSManagedObjectContext*)moc;

+(PNCloudURLToken*)insertCloudURLTokenWithMetadataItem: (NSMetadataItem*)item
                                inManagedObjectContext: (NSManagedObjectContext*)moc;

+(PNURLToken*)urlTokenForURL: (NSURL*)url;

-(PNURLToken*)urlTokenWithLocalizedName: (NSString*)newLocalizedName;

+(void)deleteURLToken: (PNURLToken*)haplessToken;

+(BOOL)deleteURLsAndURLToken: (PNURLToken*)haplessToken
                       error: (NSError**)error;

+(PNURLToken*)demote: (PNCloudURLToken*)cloudToken
               error: (NSError**)error;

+(PNCloudURLToken*)promote: (PNURLToken*)localToken
                     error: (NSError**)error;
@end
