//
//  UIManagedDocument+PNDocTokenCallbackSupporting.h
//  TaggedLocationsDemo
//
//  Created by DevGuy on 4/25/12.
//  Copyright (c) 2012 NowPicture LLC. All rights reserved.
//

//#import <UIKit/UIKit.h>
#import <CoreData/CoreData.h>
#import <UIKit/UIKit.h>

@class PNDocToken;



/**
 The UIManagedDocument (PNDocTokenCallbackSupporting) category helps UIManagedDocument interact with PNDocToken.
 This is how PNDocToken handles the callbacks for file operations.
 */
@interface UIManagedDocument (PNDocTokenCallbackSupporting)


- (void)openWithToken: (PNDocToken*)docToken;

- (void)saveToURL:(NSURL *)url 
 forSaveOperation:(UIDocumentSaveOperation)saveOperation 
            token: (PNDocToken*)docToken;

-(void)revertToContentsOfURL: (NSURL *)url
                       token: (PNDocToken*)docToken;

-(void)closeWithToken: (PNDocToken*)docToken;

@end

