#import "_PNCloseCreate.h"

#import "PNDocumentCreating.h"

@class PNDocTokenPlace;

/**
	PNCloseCreate closes one document and creates a new document.
 */
@interface PNCloseCreate : _PNCloseCreate {}
// Custom logic goes here.


// PNCreateDoc Arguments:
@property (readonly, strong) NSString *localizedName;
@property (readonly, strong) NSString *documentClassName;
@property (readonly, strong) NSArray *midPathComponents;
@property (readonly, weak) id <PNDocumentCreating> creationDelegate;

/**
 
 Typically, the sourcePlace and destPlace are the same. But, sourcePlace and destPlace could well be distinct, in the case of master/detail view controllers.
 @param aPipelineTransitionDelegate the outer transition delegate (the receiver serves as the transition delegate for its internal transitions.
 @param uuidToClose identifies the target docToken in fromPlace
 @param fromPlace the place that contains the target doc token.
 @param aLocalizedName a name for the document to be created. Needs not be unique--certainly not across devices.
 @param aDocumentClassName nil, @"UIManagedDocument" or the name of a subclass. If nil, the creationDelegate will receive -documentClassNameForUrlToken: (called from nqd_allocInitDocumentWithLocalURL).
 @param aMidPath nil, an empty array, or an array of strings suitable for path components of a document's file package URL.
 @param aCreationDelegate the creation delegate initializes the object graph of the newly instantiated document.
 @param toPlace the place that receives the product doc token.
 */
-(void)        enableFor: (id<PNTransitionDelegate>)aPipelineTransitionDelegate
               closeUuid: (NSString*)uuidToClose
               fromPlace: (PNDocTokenPlace*)fromPlace
   documentLocalizedName: (NSString*)aLocalizedName
       documentClassName: (NSString*)aDocumentClassName
       midPathComponents: (NSArray*)aMidPath
        creationDelegate: (id <PNDocumentCreating>)aCreationDelegate
                 toPlace: (PNDocTokenPlace*)toPlace;


@end
