#import "PNCloseCreate.h"

#import "PNDocSupportNet.h"

#import "PNCloseDoc.h"
#import "PNCreateDoc.h"


@interface PNCloseCreate ()
// Custom logic goes here.


// PNCreateDoc Arguments:
@property (readwrite, strong) NSString *localizedName;
@property (readwrite, strong) NSString *documentClassName;
@property (readwrite, strong) NSArray *midPathComponents;
@property (readwrite, weak) id <PNDocumentCreating> creationDelegate;

@end

@implementation PNCloseCreate

@synthesize localizedName, documentClassName, midPathComponents, creationDelegate;

// Custom logic goes here.
-(void)buildPipeline
{
    [super buildPipeline];
    
    PNDocSupportNet *dsn = self.docSupportNet;
    [m_componentTransitions addObject: dsn.closeDoc];
    [m_componentTransitions addObject: dsn.createDoc];
}
-(void)enableFor: (id<PNTransitionDelegate>)transitionDelegate
{
    NSAssert( NO, @"-[PNCloseCreate enableFor:] aborts. Use -enableFor:targetUuid:yadda:yadda:");
}

-(void)        enableFor: (id<PNTransitionDelegate>)aPipelineTransitionDelegate
               closeUuid: (NSString*)uuidToClose
               fromPlace: (PNDocTokenPlace*)fromPlace
   documentLocalizedName: (NSString*)aLocalizedName
       documentClassName: (NSString*)aDocumentClassName
       midPathComponents: (NSArray*)aMidPath
        creationDelegate: (id <PNDocumentCreating>)aCreationDelegate
                 toPlace: (PNDocTokenPlace*)toPlace
{
    self.localizedName = aLocalizedName;
    self.documentClassName = aDocumentClassName;
    self.midPathComponents = aMidPath;
    self.creationDelegate = aCreationDelegate;
    
    [super enableFor: aPipelineTransitionDelegate
      closeUuid:uuidToClose
      fromPlace:fromPlace
        toPlace: toPlace];
}

@end

@implementation PNCloseCreate (PrivateSubclassing)
-(void)fireNextTransition
{
    // Typically, subclasses of PNDocTokenTransition
    // Subclasses of PNPipeline can implement a switch/case
    // to fire each component transition with its appropriate arguments.
    switch( self.currentIndex ){
        case 0:
        {
            PNCloseDoc *t = (PNCloseDoc*)[m_componentTransitions objectAtIndex:0];
            
            [t enableFor: self
               closeUuid: self.closeUuid
               fromPlace: self.sourcePlace];
            
            break;
        }
        case 1:
        {
            PNCreateDoc *t = (PNCreateDoc*)[m_componentTransitions objectAtIndex:1];
            [t   enableFor: self
documentLocalizedName: self.localizedName
    documentClassName: self.documentClassName
              midPathComponents: self.midPathComponents
     creationDelegate: self.creationDelegate
              toPlace: self.destinationPlace];
            
            break;
        }

        default:
        {
            NSAssert( NO, @"-[PNCloseCreate fireNextTransition] aborts at self.currentIndex = %d.",
                     self.currentIndex );
            break;
        }
    }
}

@end

