#import "_PNCloseDoc.h"

/**
	PNCloseDoc closes the document in a doc token.
 */
@interface PNCloseDoc : _PNCloseDoc
{
}


/**
	Uses the uuid to identify a doc token in fromPlace. Removes the doc token, closes its document, removes the doc token's url from the appropriate assigned place, and puts it in the unassigned place.
 
 @param transitionDelegate the transition delegate to inform of success or failure
 @param uuid the uuid of the target doc token in fromPlace, to be removed
 @param fromPlace the place that holds the target doc token
 */
-(void)enableFor: (id<PNTransitionDelegate>)transitionDelegate
    closeUuid: (NSString*)uuid
    fromPlace: (PNDocTokenPlace*)fromPlace;

@end
