#import "PNCloseFlipOpen.h"
#import "PNDocSupportNet.h"

#import "PNCloseDoc.h"
#import "PNOpenDoc.h"

#import "PNFlipStorage.h"

@interface PNCloseFlipOpen ()
// Custom logic goes here.


// PNOpenDoc Arguments:
@property (readwrite, strong) NSString *closeUuid;
@property (readwrite, strong) NSString *openUuid;

@end

@implementation PNCloseFlipOpen

@synthesize closeUuid;
@synthesize openUuid;
@synthesize toCloud;

@synthesize callback;

// Custom logic goes here.


-(void)buildPipeline
{
    // Abstract parent does nothing.
    [m_componentTransitions addObject: self.docSupportNet.closeDoc];
    [m_componentTransitions addObject: self.docSupportNet.flipStorage];
    [m_componentTransitions addObject: self.docSupportNet.openDoc];
    
}

-(void)enableFor:  (id<PNTransitionDelegate>)aPipelineTransitionDelegate
         toCloud: (BOOL)flag
      targetUuid: (NSString*)targetUuid
       fromPlace: (PNDocTokenPlace*)fromPlace
         toPlace: (PNDocTokenPlace*)toPlace
{
    [self enableFor: aPipelineTransitionDelegate
            toCloud: flag
         targetUuid:targetUuid
          fromPlace:fromPlace
            toPlace:toPlace
           callback: nil];
}
-(void)enableFor:  (id<PNTransitionDelegate>)aPipelineTransitionDelegate
         toCloud: (BOOL)flag
      targetUuid: (NSString*)targetUuid
       fromPlace: (PNDocTokenPlace*)fromPlace
         toPlace: (PNDocTokenPlace*)toPlace
        callback: (NSInvocation*)aCallback
{
    self.callback = aCallback;
    self.toCloud = flag;
    
    [super enableFor: aPipelineTransitionDelegate
           closeUuid: targetUuid
           fromPlace: fromPlace
             toPlace: toPlace];
    
}
@end


@implementation PNCloseFlipOpen (PrivateSubclassing)
-(void)fireNextTransition
{
    // Typically, subclasses of PNDocTokenTransition
    // abort on -enableFor:.
    
    // Subclasses of PNPipeline can implement a switch/case
    // to fire each component transition with its appropriate arguments.
    switch( self.currentIndex ){
        case 0:
        {
            PNCloseDoc *t = (PNCloseDoc*)[m_componentTransitions objectAtIndex:0];
            
            [t enableFor: self
               closeUuid: self.closeUuid
               fromPlace: self.sourcePlace];
            
            break;
        }
        case 1:
        {
            PNFlipStorage *t = (PNFlipStorage*)[m_componentTransitions objectAtIndex:1];
            
            [t   enableFor: self
               targetUuids: [NSSet setWithObject:  self.closeUuid]
                   toCloud:  self.toCloud];
            
            break;
        }
        case 2:
        {
            PNOpenDoc *t = (PNOpenDoc*)[m_componentTransitions objectAtIndex:2];
            [t enableFor: self
                    uuid: self.closeUuid
                 toPlace:self.destinationPlace];
            
            break;
        }
        default:
        {
            NSAssert( NO, @"-[PNCloseOpen fireNextTransition] aborts at self.currentIndex = %d.",
                     self.currentIndex );
            break;
        }
    }
}

-(void)didTransform
{
    [super didTransform];
    
    if( nil == m_error ){
        [self.callback invoke];
    }
}

@end
