#import "PNCloseOpen.h"

#import "PNDocSupportNet.h"

#import "PNCloseDoc.h"
#import "PNOpenDoc.h"



@interface PNCloseOpen ()
// Custom logic goes here.


// PNOpenDoc Arguments:
@property (readwrite, strong) NSString *openUuid;

@end

@implementation PNCloseOpen

@synthesize openUuid;

// Custom logic goes here.
-(void)buildPipeline
{
    [super buildPipeline];
    
    PNDocSupportNet *dsn = self.docSupportNet;
    [m_componentTransitions addObject: dsn.closeDoc];
    [m_componentTransitions addObject: dsn.openDoc];
}

-(void)enableFor: (id<PNTransitionDelegate>)aPipelineTransitionDelegate
    closeUuid: (NSString*)uuidToClose
    fromPlace: (PNDocTokenPlace*)fromPlace
     openUuid: (NSString*)uuidToOpen
      toPlace: (PNDocTokenPlace*)toPlace
{
    self.openUuid = uuidToOpen;
    
    [super enableFor: aPipelineTransitionDelegate
      closeUuid:uuidToClose
      fromPlace:fromPlace
        toPlace: toPlace];
}

@end


@implementation PNCloseOpen (PrivateSubclassing)
-(void)fireNextTransition
{
    // Typically, subclasses of PNDocTokenTransition
    // Subclasses of PNPipeline can implement a switch/case
    // to fire each component transition with its appropriate arguments.
    switch( self.currentIndex ){
        case 0:
        {
            PNCloseDoc *t = (PNCloseDoc*)[m_componentTransitions objectAtIndex:0];
            
            [t enableFor: self
          closeUuid: self.closeUuid
          fromPlace: self.sourcePlace];
            
            break;
        }
        case 1:
        {
            PNOpenDoc *t = (PNOpenDoc*)[m_componentTransitions objectAtIndex:1];
            [t   enableFor: self
                 uuid: self.openUuid
              toPlace: self.destinationPlace];
            
            break;
        }
            
        default:
        {
            NSAssert( NO, @"-[PNCloseOpen fireNextTransition] aborts at self.currentIndex = %d.",
                     self.currentIndex );
            break;
        }
    }
}

@end
