#import "PNCreateDoc.h"

#import "PNTransition+Transforming.h"

#import "PNDocToken+FileOperations.h"
#import "PNDocToken+LifeCycling.h"

#import "PNArcT2P.h"
#import "PNDocTokenPlace.h"
#import "PNDocSupportNet.h"

//#import "PNURLTokenPlace.h"
#import "PNDocTokenPlace.h"

#import "NSManagedObject+PNPermanentIDing.h"

#import "PNURLToken+LifeCycling.h"
#import "PNCloudURLToken.h"

#import "PNDocSupportNetController.h"
#import "PNDocSupportNetController+StorageControlling.h"

#import "PNDocToken+Managing.h"
@interface PNCreateDoc ()

@property (readwrite, strong) NSString *localizedName;
@property (readwrite, strong) NSString *documentClassName;
@property (readwrite, strong) NSArray *midPathComponents;
@property (readwrite, strong) id <PNDocumentCreating> creationDelegate;

@end

@implementation PNCreateDoc

@synthesize creationDelegate;

@synthesize localizedName;
@synthesize documentClassName;
@synthesize midPathComponents;

@dynamic createdURLToken;
@dynamic createdDocToken;

// Custom logic goes here.

-(PNArcP2T*)arcFromUnassignedLocal
{
    return nil;
}
-(PNArcP2T*)arcFromUnassignedCloud
{
    return nil;
}
-(PNArcT2P*)arcToUnassignedLocal
{
    return nil;
}
-(PNArcT2P*)arcToUnassignedCloud
{
    return nil;
}
-(PNArcP2T*)arcFromAssignedLocal
{
    return nil;
}
-(PNArcP2T*)arcFromAssignedCloud
{
    return nil;
}
//-(PNArcT2P*)arcToAssignedLocal
//{
//    return nil;
//}
//-(PNArcT2P*)arcToAssignedCloud
//{
//    return nil;
//}
//-(PNArcT2P*)arcToDestination
//{
//    return nil;
//}
-(PNArcP2T*)arcFromSource
{
    return nil;
}
-(PNDocTokenPlace*)sourcePlace
{
    return nil;
}

//-(void)setSourcePlace:(PNDocTokenPlace *)aSourcePlace
//{
//    NSAssert( NO, @"%@ has no source place",
//             NSStringFromClass([self class]) );
//    
//}
//-(PNDocTokenPlace*)destinationPlace
//{
//    NSManagedObjectContext *moc = self.managedObjectContext;
//    return (PNDocTokenPlace*)[moc managedObjectForPermanentID: m_permID_destinationPlace];
//}
//-(void)setDestinationPlace:(PNDocTokenPlace *)aDestinationPlace
//{
//    NSAssert( NO, @"%@ has no destination place",
//             NSStringFromClass([self class]) );
//}


-(void)enableFor: (id<PNTransitionDelegate>)transitionDelegate
{
    NSAssert( NO, @"-[PNCreateDoc enableFor:] aborts. Use -enableFor:documentLocalizedName:documentClassName:midPathComponents:creationDelegate:toPlace:");
}

-(void)          enableFor: (id<PNTransitionDelegate>)transitionDelegate
     documentLocalizedName: (NSString*)aLocalizedName
         documentClassName: (NSString*)aDocumentClassName
         midPathComponents: (NSArray*)aMidPath
          creationDelegate: (id <PNDocumentCreating>)aCreationDelegate
                   toPlace: (PNDocTokenPlace*)toPlace
{
    NSArray *nonNilMidPath = aMidPath;
    if( nil == nonNilMidPath ){
        nonNilMidPath = [NSArray array];
    }
    
    self.localizedName = aLocalizedName;
    self.documentClassName = aDocumentClassName;
    self.midPathComponents = aMidPath;
    if( nil == self.midPathComponents ){
        self.midPathComponents = [NSArray array];
    }
    self.creationDelegate = aCreationDelegate;
    m_permID_destinationPlace = [toPlace permanentID];
    m_permID_createdURLToken = nil;
    m_permID_createdDocToken = nil;
   
    self.sourceUuid = nil;
    self.destinationUuid = nil;
    
    [super enableFor: transitionDelegate];
    
}

@end

@implementation PNCreateDoc (Transforming)
-(PNURLToken*)createdURLToken
{
    PNURLToken *result = nil;
    NSManagedObjectContext *moc = self.managedObjectContext;
    if( nil == m_permID_createdURLToken ){
         
          NSDictionary *properties =
        [NSDictionary dictionaryWithObjectsAndKeys:
         self.midPathComponents,           PNMidPathComponentsKey,
         [PNURLToken nextUuid],  PNUuidStringKey,
         self.localizedName,     PNLocalizedNameKey,
         self.documentClassName, PNDocumentClassNameKey,
         nil];
        
        PNDocSupportNetController *dsnc = [PNDocSupportNetController sharedDocSupportNetController];

        switch( dsnc.storageStatus ){
            case PNStorageStatusCloudAccountAvailable:
            {
                result = [PNURLToken insertCloudURLTokenWithProperties: properties
                                                inManagedObjectContext: moc];
                break;
            }
            case PNStorageStatusCloudAccountIndeterminate:
            case PNStorageStatusCloudAccountUnavailable:
            case PNStorageStatusLocalStorageByDefault:
            case PNStorageStatusLocalStorageForever:
            {
                
                result = [PNURLToken insertLocalURLTokenWithProperties: properties
                                                inManagedObjectContext: moc];
                break;
            }
            default:
            {
                NSAssert( NO, @"-createdURLToken found bogus storage status %d",
                         dsnc.storageStatus);
                break;
            }
        }

        
        result.isAvailableValue = YES;
        
        self.sourceUuid = nil;
        
        self.destinationUuid = result.uuid;
        
        m_permID_createdURLToken = [result permanentID];
    }
    result = (PNURLToken*)[moc managedObjectForPermanentID: m_permID_createdURLToken];
    
    return result;
}
-(PNDocToken*)createdDocToken
{
    PNDocToken *result= nil;
    NSManagedObjectContext *moc = self.managedObjectContext;
    if( nil == m_permID_createdDocToken ){
        
        result = [PNDocToken docTokenWithURLToken: self.createdURLToken
                                 creationDelegate: creationDelegate];
        
        result.isAvailableValue = YES;
        m_permID_createdDocToken = [result permanentID];
    }
    result = (PNDocToken*)[moc managedObjectForPermanentID: m_permID_createdDocToken];
    
    return result;
}
-(void)gatherDocToken
{
    self.docToken = self.createdDocToken;
        
    [self.innerPlace addToken: self.docToken];
}
-(void)launchTransform
{
     [self.docToken createAndSaveDocument];
    
    // callbacks: -docTokenDidBecomeAvailable: or -docToken:didFailWithError:
    // Call [super transform] from -docTokenDidBecomeAvailable: or -docToken:didFailWithError:.
    
    self.assignedOut = [NSSet setWithObject: self.docToken.urlToken];
}
@end