#import "PNDeleteUUIDs.h"

#import "PNTransition+Transforming.h"

#import "PNURLToken.h"
#import "PNURLToken+LifeCycling.h"

#import "PNDocSupportNet.h"

@implementation PNDeleteUUIDs
@synthesize allURLTokensIn;

// Custom logic goes here.

@end


@implementation PNDeleteUUIDs (Transforming)


-(void)transform
{
    NSLog( @"-[%@ transform] for real", NSStringFromClass([self class]));

    NSError *transformError = nil;
       
    NSMutableSet *allTokens = [self.localURLTokensIn mutableCopy];
    [allTokens addObjectsFromArray: [self.cloudURLTokensIn allObjects]];
    
    for( PNURLToken *next in allTokens ){
        
        [PNURLToken deleteURLsAndURLToken:next
                                    error:&transformError];
        
        if( nil == transformError ){
            
            // The contrary case:
            // If we DON'T get an error, remove the url token in the scatter operation:
            [self.tokensToDeleteInScatter addObject: next];
            
        }else{
            // If we got an error, preserve the url token for recovery:
            break; // and break out of the for loop.
        }
    }
    [self.localURLTokensOut removeAllObjects];
    [self.cloudURLTokensOut removeAllObjects];
    
    m_error = transformError;
    
    [super transform];
}
@end

