#import "PNFlipStorage.h"

#import "PNTransition+Transforming.h"

#import "PNURLToken.h"
#import "PNCloudURLToken.h"
#import "PNURLToken+LifeCycling.h"

@interface PNFlipStorage ()

// Private interface goes here.

@end


@implementation PNFlipStorage
@synthesize toCloud;

@synthesize callback;

// Custom logic goes here.

-(void)enableFor: (id<PNTransitionDelegate>)transitionDelegate
         toCloud: (BOOL)flag
        callback: (NSInvocation*)aCallback
{
    self.callback = aCallback;
    self.toCloud = flag;
    
    [super enableFor: transitionDelegate
         targetUuids: [NSSet set]];
}

-(void)enableFor: (id<PNTransitionDelegate>)transitionDelegate
     targetUuids: (NSSet*)targetUuids
         toCloud: (BOOL)flag
{
    self.toCloud = flag;
    
    [super enableFor: transitionDelegate
         targetUuids: targetUuids];
}
@end

@implementation PNFlipStorage (Transforming)
-(void)promoteLocalURLTokens
{
    if( nil != m_error ) return;
    
    NSError *localError = m_error;
    
    // self.uuids = {NSSet set]; // Should gather all local tokens
    for( PNURLToken *local in self.localURLTokensIn ){
        
        PNCloudURLToken *cloud = [PNURLToken promote: local
                                               error: &localError];
        
        if( nil == localError ){
            [self.cloudURLTokensOut addObject: cloud];
        }else{
            m_error = localError;
            break;
        }
        
    }
    if( nil != localError ){
        m_error = localError;
    }
    
}
-(void)demoteCloudURLTokens
{
    if( nil != m_error ) return;
    
    NSError *localError = m_error;
    
    // self.uuids = [NSSet set]; // Should gather all local tokens
    for( PNCloudURLToken *cloud in self.cloudURLTokensIn ){
        
        PNURLToken *local = [PNURLToken demote: cloud
                                         error: &localError];
        
        if( nil == localError ){
            [self.localURLTokensOut addObject: local];
        }else{
            m_error = localError;
            break;
        }
        
    }
    if( nil != localError ){
        m_error = localError;
    }
    
}
-(void)transform
{
    if( self.toCloud ){
        [self promoteLocalURLTokens];
    }else{
        [self demoteCloudURLTokens];
        
        [super cleanDirectory: [PNCloudURLToken containerUrl]];
        [super cleanDirectory: [PNCloudURLToken changeLogsContainerUrl]];
    }
    
    [super transform];
}

-(void)didTransform
{
    [super didTransform];
    
    if( nil == m_error ){
        [self.callback invoke];
    }
}

@end