#import "_PNOpenDoc.h"

#import "PNDocumentCreating.h"

@class PNDocTokenPlace, PNDocToken, PNArcT2P;

/**
	PNOpenDoc gathers one url token from an unassigned place, creates a doc token, instantiates and opens the doc token's document, and scatters the url token to the assigned place.
 */
@interface PNOpenDoc : _PNOpenDoc
{
    
}

/**
	Gathers one url token identified by uuid from an unassigned place, creates a doc token, instantiates and opens the doc token's document, and scatters the url token to the assigned place. The transition fails if the document cannot be opened successfully to [Normal] state.
 
 @param transitionDelegate the transition delegate to inform of success or failure
 @param uuid the uuid of the target url token in an unassigned place.
 @param toPlace the place that will receive the new doc token on success of the transition.
*/
-(void)enableFor: (id<PNTransitionDelegate>)transitionDelegate
       uuid: (NSString*)uuid
    toPlace: (PNDocTokenPlace*)place;

@end
