#import "_PNQueryUpdate.h"

/**
 Called in response to the NSMetadataQuery update.
 Builds a new cloud url token as required for any unmatched incoming metadata items.
 ("Unmatched" means we have no existing cloud url token of the same uuid as the incoming metadata item's uuid.)
 
 */
@interface PNQueryUpdate : _PNQueryUpdate {}
// Custom logic goes here.

/**
 An invocation. The -didTransform method invokes the callback if no error occurs.
 */
@property (readwrite, strong) NSInvocation *callback;

+(NSSet*)filteredQueryResults: (NSArray*)unfilteredQueryResults;

/**
 Calls -enableFor:targetUuids: and specifies the callback.
 */
-(void)enableFor: (id<PNTransitionDelegate>)transitionDelegate
   metadataItems: (NSSet*)metadataItemsToBuild
        callback: (NSInvocation*)aCallback;

@end

@interface PNQueryUpdate (Transforming)

+(NSString*)uuidFromMetadataItem: (NSMetadataItem*)item;

@end