#import "_PNRenameDoc.h"

#import "PNTransitionDelegate.h"

/**
 PNRenameDoc only operates on local documents, circa 2013 mid-April.
 
 */
@interface PNRenameDoc : _PNRenameDoc
{
    NSURL *m_permID_differentURLToken;

}

@property (readonly, strong) NSString *differentName;
@property (readonly, strong) PNURLToken *originalURLToken;
@property (readonly, strong) PNURLToken *differentURLToken;


/**
 
 Gathers the doc token with anExistingUuid from sourcePlace, closes it document, removes the doc token's url token from the assigned place, generates a new url token with a new uuid and the new name, assigns it to the doc token, renames the document, puts the doc token in destPlace, and puts the new url token in the assigned place.
 
 Typically, the sourcePlace and destPlace are the same. But, sourcePlace and destPlace could well be distinct, in the case of master/detail view controllers.
 
 @param sender the transition delegate to inform of success or failure
 @param anExistingUuid the uuid of the target doc token in fromPlace, to be removed and renamed
 @param fromPlace the place that holds the target doc token
 @param aNewName new name for the new document
 @param toPlace the place that receive the doc token bearing the new renamed copy of the original document
 @param deleteOriginalFlag YES to delete the original, NO otherwise.
 */
-(void)   enableFor: (id <PNTransitionDelegate>)sender
       existingUuid: (NSString*)anExistingUuid
           renameTo: (NSString*)aNewName
          fromPlace: (PNDocTokenPlace*)sourcePlace
            toPlace: (PNDocTokenPlace*)destPlace
     deleteOriginal: (BOOL)deleteOriginalFlag;



@end
