#import "_PNSyncResources.h"

/**
 Called at application launch time from PNDocSupportNetController.
 
 PNSyncResources inspects the local file system. It builds a url token for every file of the form
    <NSDocumentDirectory()>/<uuid>/<fileName>
 or 
    <NSDocumentDirectory()>/blah/blah/<uuid>/<fileName>
 
 where "blah" is never a valid uuid in string form.
 
 PNSyncResources might be repurposed for service after application launch time. That's one reason it's a PNURLTransition subclass rather than just a collection of methods in PNDocSupportNetController.
 
 */
@interface PNSyncResources : _PNSyncResources {}
// Custom logic goes here.

/**
	An invocation. The -didTransform method invokes the callback if no error occurs.
 */
@property (readwrite, strong) NSInvocation *callback;
/**
 Calls -enableFor:targetUuids: and specifies the callback.
 */
-(void)enableFor: (id<PNTransitionDelegate>)transitionDelegate
     targetUuids: (NSSet*)targetUuids
        callback: (NSInvocation*)aCallback;
@end
