//
//  PNTransition+Transforming.h
//  TaggedLocationsDemo
//
//  Created by DevGuy on 10/18/12.
//
//

#import "PNTransition.h"

#import "PNDeleteUUIDs.h"
#import "PNArcP2T.h"

@class PNURLTokenPlace, PNURLToken;

/**
 The Transforming category should be hidden from the adopting developer.
 
 */

@interface PNTransition (Transforming)

/**
	Pulls appropriate input tokens from input arcs (and so from upstream places). See also: -scatterTokens.
 */
-(void)gatherTokens;

/**
 The -transform method encapsulates the receiver's operation on its input tokens, and produces its output tokens. The abstract parent PNTransition's -transform method does nothing except call -didTransform in an asych block on the main queue. Subclass implementations should call [super transform] at end.
 */
-(void)transform;


/**
	Reports to the receiver's transition delegate the success or failure of the transform operation.
 */
-(void)didTransform;

/**
	Pushes output tokens through output arcs (and so to downstream places). See also: -gatherTokens.
 */
-(void)scatterTokens;

-(void)cleanDirectory: (NSURL*)targetDirectory;

@end
