//
//  PNTransition+Transforming.m
//  TaggedLocationsDemo
//
//  Created by DevGuy on 10/18/12.
//
//

#import "PNTransition+Transforming.h"

#import "PNURLTokenPlace.h"
#import "PNURLToken.h"

#import "PNURLTokenPlace.h"

#import "PNArcP2T.h"

#import "PNDocSupportNetController.h"

#import "PNNet.h"

@implementation PNTransition (Transforming)


-(void)gatherTokens
{
    // Abstract parent just squawks.
    
    NSLog(@"-[%@ gatherTokens]", NSStringFromClass([self class]));
    return;
}
-(void)transform
{

    // PNTransition, Abstract parent
    // subclass implementations should call [super transform] at end.
    
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       [self didTransform];
                   }
                   ); 
}

-(void)didTransform
{
    BOOL isMainThread = [[NSThread currentThread] isMainThread];
    NSAssert( isMainThread, @"-didTransform called in background.");
    
    @synchronized(self.net){
        
        NSLog( @"-[%@ didTransform]", NSStringFromClass([self class]));
        

        BOOL success = ( nil == m_error );
        
        if( success ){ // before unlocking
            
            [self scatterTokens];
            
            // tell the transition delegate the operation succeeded:
            [m_transitionDelegate didFireTransition: self];
                        
        }else{
            
            [m_transitionDelegate didFailTransition: self
                             rolledBackSuccessfully: NO];
        }
        
        [self.net didFireTransition: self
                       successfully: success];
        
    }//@synchronized(self.net);

}

-(void)scatterTokens
{
    // Abstract parent just squawks.
    
    NSLog(@"-[%@ scatterTokens]", NSStringFromClass([self class]));
}
-(void)cleanDirectory: (NSURL*)targetDirectory
{
    NSError __block *localError = nil;
    
    NSNumber *isDir = NO;
    [targetDirectory getResourceValue: &isDir
                               forKey: NSURLIsDirectoryKey
                                error: &localError];
    
    NSAssert( [isDir boolValue],
             @"Bogus url is not a directory: %@",
             [targetDirectory description]);
    
    if( nil != localError ){
        m_error = localError;
    }
    
    NSFileManager *fileMngr =
    [PNDocSupportNetController threadSafeFileManager];
    
    NSFileCoordinator* coordinator =
    [[NSFileCoordinator alloc] initWithFilePresenter:nil];
    [coordinator coordinateWritingItemAtURL:targetDirectory
                                    options:NSFileCoordinatorWritingForDeleting
                                      error:&localError
                                 byAccessor:^(NSURL *dirURL) {
                                     
                                     NSArray *contents =
                                     [fileMngr contentsOfDirectoryAtURL:dirURL
                                             includingPropertiesForKeys: nil
                                                                options: NSDirectoryEnumerationSkipsSubdirectoryDescendants
                                                                  error: &localError];
                                     
                                     if( nil == localError ){
                                         for( NSURL *nextURL in contents ){
                                             [fileMngr removeItemAtURL:nextURL
                                                                 error:&localError];
                                             
                                             if( nil != localError ){
                                                 break;
                                             }
                                         }
                                         
                                     }
                                     
                                 }];
    if( nil != localError ){
        m_error = localError;
    }
}

@end


