#import "PNTransition.h"

#import "PNTransition+Transforming.h"

#import "PNTransitionDelegate.h"

#import "PNDocSupportNet.h"

#import "PNArcP2T.h"
#import "PNArcT2P.h"

//NSString *PNTransitionsDidStart    = @"PNTransitionsDidStart";
//NSString *PNTransitionsDidFailAndSuspend  = @"PNTransitionsDidFailAndSuspend";
//NSString *PNTransitionsDidConclude = @"PNTransitionsDidConclude";

@interface PNTransition ()
@property (readwrite, strong) NSError *error;
@end

@implementation PNTransition
@synthesize error = m_error;
@dynamic docSupportNet;


-(PNDocSupportNet*)docSupportNet
{
    PNNet *net = self.net;
    if( [net isKindOfClass: [PNDocSupportNet class]]){
        return (PNDocSupportNet*)net;
    }else{
        return nil;
    }
}

-(void)muster: (NSManagedObject*)foo
{
    /**
     Empty for now.
     During -connectFixedArcs, the fixed arcs pass through as arguments. 
     
     The initial reason for this method is that in -connectFixedArcs,
     if I just call the getter, I get a compiler warning:
        -(void)connectFixedArcs
        {
            self.foo; //! Property access result unused - getters should not be used for side effects
        }
     So instead, I do this:
        -(void)connectFixedArcs
        {
            [self muster: self];
        }
     The compiler is completely fooled -- no warnings.
     */
    
}
-(void)connectFixedArcs
{
    [self muster: nil];
}
-(void)disconnectFixedArcs
{
    
}


-(void)enableFor:(id<PNTransitionDelegate>)sender
{
    @synchronized(self.net){
        
        NSLog(@"-[%@ enableFor: %@]",
              NSStringFromClass( [self class]),
              NSStringFromClass( [sender class]) );
        m_transitionDelegate = sender;
        
        [self gatherTokens];
        
        [m_transitionDelegate setActiveTransition: self];
        
        [self.net addToFiringSequence: self];
        
    } // @synchronized (self.net)
}
-(void)fire
{
    [self.net willFireTransition: self];
    [self transform];
}
-(NSString*)quickLook
{
    
    // [1] name
    NSMutableString *result = [NSMutableString stringWithFormat:@"%@\n", self.name];
    
    // [2] in arcs:
    [result appendString: @"inArcs:\n"];
    for( PNArcP2T *nextIn in self.inArcs ){
        [result appendFormat: @"%@\n",
         [nextIn route]];
    }
    
    // [3] out arcs:
    [result appendString: @"outArcs:\n"];
    for( PNArcT2P *nextOut in self.outArcs ){
        [result appendFormat: @"%@\n",
         [nextOut route]];
    }
    
    
    return result;
}

@end
