#import "_PNURLTokensTransition.h"




@class PNURLToken;

/**
	PNURLTokensTransition encapsulates an operation on PNURLTokens. It also has input and output arces.
 */
@interface PNURLTokensTransition : _PNURLTokensTransition
{
    NSSet *m_uuids;
    
    NSURL *m_permID_arcFromUnassignedLocal;
    NSURL *m_permID_arcFromUnassignedCloud;
    
    // Note: Subclass PNDeleteUUIDs does not use these:
    NSURL *m_permID_arcToUnassignedLocal;
    NSURL *m_permID_arcToUnassignedCloud;
    
    NSMutableSet *m_tokensToDeleteInScatter;
    NSMutableSet *m_localURLTokensOut;
    NSMutableSet *m_cloudURLTokensOut;
}
// Custom logic goes here.

@property (readwrite, strong) NSSet *uuids;
@property (readonly, strong) PNArcP2T *arcFromUnassignedLocal;
@property (readonly, strong) PNArcP2T *arcFromUnassignedCloud;

// Note: Subclass PNDeleteUUIDs does not use these:
@property (readonly, strong) PNArcT2P *arcToUnassignedLocal;
@property (readonly, strong) PNArcT2P *arcToUnassignedCloud;

@property (readwrite, strong) NSSet *localURLTokensIn;
@property (readwrite, strong) NSSet *cloudURLTokensIn;
@property (readwrite, strong) NSSet *allURLTokensIn;

@property (readonly, strong) NSMutableSet *localURLTokensOut;
@property (readonly, strong) NSMutableSet *cloudURLTokensOut;

@property (readonly, strong) NSMutableSet *tokensToDeleteInScatter;

/**
	Extension of -[PNTransition enableFor:] that specifies a ne value for the uuids property.
 */
-(void)enableFor: (id<PNTransitionDelegate>)transitionDelegate
     targetUuids: (NSSet*)targetUuids;

@end
