//
//  NSString+PNEllipsis.h
//  TaggedLocationsDemo
//
//  Created by DevGuy on 1/4/13.
//
//

#import <Foundation/Foundation.h>

/**
	This category on NSString is intended for development only. UUIDs in string form are inconveniently long, especially for table views on the iPhone in portrait mode.
 
	However, during development, it's convenient to distinguish documents with similar names (@"Untitled", @"Untitled 1", ...). This category provides a method to help.
 */
@interface NSString (PNEllipsis)

/**
	Intended for strings that represent UUIDs. For example, @"4FF18CF9-1392-4250-B3EA-2518FAB42FD5" returns @"4FF...FD5" 
	@returns the receiver in ellipsis form
 */
-(NSString*)pnEllipsis;
@end
