//
//  NSURL+NPAssisting.m
//  TaggedLocationsDemo
//
//  Created by DevGuy on 9/10/12.
//
//

#import "NSURL+NPAssisting.h"

#import "PNDocSupportNet.h"
#import "PNDocSupportNetController.h"

#import "PNURLToken.h"

NSString *slash = @"/";

static NSString *cloudSignature     = @"/var/mobile/Library/Mobile%20Documents/" ;
static NSString *deviceSignature    = @"/var/mobile/Applications/";
static NSString *simulatorSignature = @"/Library/Application%20Support/iPhone%20Simulator/";

@implementation NSURL (NPAssisting)
//-(NSURL*)resolvedURL
//{
//    /*
//     This method should resolve:
//     [1] file://localhost/var/mobile/Applications/yadda/yadda
//     to 
//     [2] file://localhost/private/var/mobile/Applications/yadda/yadda
//     
//     See: http://www.westwind.com/reference/os-x/invisibles.html
//    
//     Mac OS X Hidden Files & Directories
//     /private	
//     
//        In OS X certain root level directories are actually symbolic links (similar to aliases) to directories in /private. 
//        Examples are /cores, /etc, and /var which are respectively linked to 
//        /private/cores, /private/etc, and /private/var. 
//        /private also contains a directory of drivers for certain peripherals.
//     
//     */
//    
//    NSFileManager *fileMngr = [PNDocSupportNetController threadSafeFileManager];
//    NSString *path = [fileMngr destinationOfSymbolicLinkAtPath: [self path]
//                                                         error: NULL];
//    
//    NSURL *resolved = nil;
//    
//    if( nil == path ){
//        resolved = [self copy];
//    }else{
//        resolved = [[NSURL URLWithString: path] copy];
//    }
//
//    return resolved;
//}
-(NSURL*)pnNormalizedURL
{
    
    NSURL *step1 = [self URLByResolvingSymlinksInPath];
    NSURL *step2 = [step1 URLByStandardizingPath];
    
//    NSString *path0 = [self path];
//    NSString *path1 = [step1 path];
//    NSString *path2 = [step2 path];
//
//    if( ![path0 isEqualToString: path2] ){
//        
//        /*
//         Example:
//         pnNormalizedURL:
//         /private/var/mobile/Applications/CB7B8FC9-8756-4123-B624-C0C510DC438A/Documents/4FF18CF9-1392-4250-B3EA-2518FAB42FD5/Untitled ->
//                 /var/mobile/Applications/CB7B8FC9-8756-4123-B624-C0C510DC438A/Documents/4FF18CF9-1392-4250-B3EA-2518FAB42FD5/Untitled ->
//                 /var/mobile/Applications/CB7B8FC9-8756-4123-B624-C0C510DC438A/Documents/4FF18CF9-1392-4250-B3EA-2518FAB42FD5/Untitled
//
//         */
//    
//
//        NSLog(@" -normalizedURL:  \n\t %@ -> \n\t %@ -> \n\t %@",
//              path0,
//              path1,
//              path2);
//    }
    return [step2 copy];
}
-(NSString*)stringFromBaseCase: (enum PNUrlBaseCase)baseCase
{
    NSString *result= nil;
    switch (baseCase) {
        case PNUrlBaseCaseInvalid:
        {
            result = @"PNUrlBaseCaseInvalid";
            break;
        }
        case PNUrlBaseCaseLocal:
        {
            result = @"PNUrlBaseCaseLocal";
            break;
        }
        case PNUrlBaseCaseCloud:
        {
            result = @"PNUrlBaseCaseCloud";
            break;
        }
        case PNUrlBaseCaseSimulator:
        {
            result = @"PNUrlBaseCaseSimulator";
            break;
        }
        default:
        {
            result = @"<unknown value>";
            break;
        }
    }
    result =
    [NSString stringWithFormat: @"%@ (%d)",
     result,
     baseCase ];
    
    return result;
}
-(enum PNUrlBaseCase)baseCase
{
    NSString *d = [self pnNormalizedURL].absoluteString;
    
    NSRange cr = [d rangeOfString: cloudSignature];
    NSRange dr = [d rangeOfString: deviceSignature];
    NSRange sr = [d rangeOfString: simulatorSignature];
    
    BOOL gotCloud =
    ((NSNotFound != cr.location) &&
     (cloudSignature.length == cr.length) &&
     (NSNotFound == dr.location) &&
     (NSNotFound == sr.location) );
    
    BOOL gotDevice =
    ((NSNotFound != dr.location) &&
     (deviceSignature.length == dr.length) &&
     (NSNotFound == cr.location) &&
     (NSNotFound == sr.location));
    
    BOOL gotSimulator =
    ((NSNotFound != sr.location) &&
     (simulatorSignature.length == sr.length) &&
     (NSNotFound == cr.location) &&
     (NSNotFound == dr.location) );
    
    if( gotCloud && !gotDevice && !gotSimulator ){
        return PNUrlBaseCaseCloud;
    }
    if( !gotCloud && gotDevice && !gotSimulator ){
        return PNUrlBaseCaseLocal;
    }
    if( !gotCloud && !gotDevice && gotSimulator ){
        return PNUrlBaseCaseSimulator;
    }
    
    return PNUrlBaseCaseInvalid;
}
+(NSString*)shibbolethForBaseCase:(enum PNUrlBaseCase)baseCase // unused, but
{
    NSString *shibboleth = @"bogus";
    switch (baseCase) {
        case PNUrlBaseCaseCloud:
        {
            shibboleth = cloudSignature;
             break;
        }
        case PNUrlBaseCaseLocal:
        {
            shibboleth = deviceSignature;
            break;
        }
        case PNUrlBaseCaseSimulator:
        {
            shibboleth = simulatorSignature;
            break;
        }
        default:
        {
            NSAssert( NO, @"Bogus baseCase = %d", baseCase );
            break;
        }
           
    }
    return shibboleth;
}
-(enum PNURLDeploymentCase)deploymentCase
{
    // bad base          -> PNURLDeploymentCaseInvalid
    // bad uuid dir name -> PNURLDeploymentCaseInvalid
    
    NSURL *normalizedURL = [self pnNormalizedURL];
    
    enum PNUrlBaseCase baseCase = [normalizedURL baseCase];
    if( PNUrlBaseCaseInvalid == baseCase ){
        NSLog(@"-deploymentCase %@ -> baseCase  %@",
              [normalizedURL description],
              [normalizedURL stringFromBaseCase: baseCase]);
        return PNURLDeploymentCaseInvalid; 
    }
    
    NSURL *uuidDir = [normalizedURL URLByDeletingLastPathComponent];
    NSString *testUuidDirName = [uuidDir lastPathComponent];
    BOOL validUuid = [PNURLToken validUuid: testUuidDirName];
    
    if( !validUuid ){
        NSLog(@"-deploymentCase %@ -> !validUuid  %@",
              [normalizedURL description],
              testUuidDirName);
        return PNURLDeploymentCaseInvalid;
    }
    
    
    NSError *error = nil;
    NSArray *resourceKeys = @[NSURLIsReadableKey, NSURLIsWritableKey, NSURLIsDirectoryKey];
    // No NSURLFileResourceIdentifierKey,
    
    NSDictionary *resourceValues = [uuidDir resourceValuesForKeys:resourceKeys
                                                           error: &error];
    
    BOOL uuidDirIsReadable  = [[resourceValues objectForKey: NSURLIsReadableKey]  boolValue];
    BOOL uuidDirIsWriteable = [[resourceValues objectForKey: NSURLIsWritableKey]  boolValue];
    BOOL uuidDirIsDirectory = [[resourceValues objectForKey: NSURLIsDirectoryKey] boolValue];

    if( !uuidDirIsDirectory ||  !uuidDirIsReadable || !uuidDirIsWriteable ){
        NSLog(@"-deploymentCase -> PNURLDeploymentCaseNoUuidDir: %@",
              [normalizedURL description]);
        
        NSLog(@"uuidDirIsDirectory %d, uuidDirIsReadable %d, uuidDirIsWriteable %d",
              uuidDirIsDirectory, uuidDirIsReadable, uuidDirIsWriteable );

        return PNURLDeploymentCaseNoUuidDir;

    }
    resourceValues = [normalizedURL resourceValuesForKeys:resourceKeys
                                                                error: &error];
    
    BOOL selfIsReadable  = [[resourceValues objectForKey: NSURLIsReadableKey]  boolValue];
    BOOL selfIsWriteable = [[resourceValues objectForKey: NSURLIsWritableKey]  boolValue];
    BOOL selfIsDirectory = [[resourceValues objectForKey: NSURLIsDirectoryKey] boolValue];
    
    if( !selfIsDirectory && !selfIsReadable && !selfIsWriteable ){
        
        // [2] The path is OK through the UUID dir, but ... no such file or directory
        NSLog(@"-deploymentCase -> PNURLDeploymentCaseUuidDirSlashNoSuchFileOrDirectory: %@",
              [normalizedURL description]);
        return PNURLDeploymentCaseUuidDirSlashNoSuchFileOrDirectory;
    }
    
    if( selfIsDirectory && selfIsReadable && selfIsWriteable ){
        
        NSArray *siblings = [self siblingsWithError: nil];
        
        if( 1 != siblings.count ){
            NSLog(@"-deploymentCase -> PNURLDeploymentCaseDefective: %@",
                  [normalizedURL description]);
            NSLog(@"  siblings.count = %d", siblings.count);

            return PNURLDeploymentCaseDefective;
        }

        // [3] this is the common case for the fileURL of a document we'll open from an existing file.
        NSLog(@"-deploymentCase -> PNURLDeploymentCaseUuidDirSlashExistingRWDir: %@",
              [normalizedURL description]);
        return PNURLDeploymentCaseUuidDirSlashExistingRWDir;
    }else{
        
        // [4] this is a rare case:
        //     we initialize a UIManagedDocument with such a URL,
        //     but as soon as we save the doc for creating, its fileURL is a directory.
        if( !selfIsDirectory && selfIsReadable && selfIsWriteable ) {
            return PNURLDeploymentCaseUuidDirSlashExistingFile;
        }else{
            
            NSLog(@"-deploymentCase -> PNURLDeploymentCaseDefective: %@",
                  [normalizedURL description]);
            
            NSLog(@"selfIsDirectory %d, selfIsReadable %d, selfIsWriteable %d",
                  selfIsDirectory, selfIsReadable, selfIsWriteable );
            
            return PNURLDeploymentCaseDefective;

        }

    }
    
    return PNURLDeploymentCaseInvalid;
}

-(NSURL*)URLByAppendingPathComponents: (NSArray*)components
                          isDirectory: (BOOL)flag;
{
    NSURL *result = [self copy];
    for( NSString *component in components ){
        NSAssert( [component isKindOfClass: [NSString class]],
                 @"component %@ is not a string", component);
        
        // Typically, 'component' contains no slash,
        // and we get just one element in 'inner', namely 'component'.
        NSArray *inner = [component componentsSeparatedByString: slash];
        for( NSString *next in inner ){
            
            NSAssert( [next isKindOfClass: [NSString class]],
                     @"component %@ is not a string", next);
            
            // Below, the isDirectory: argument is YES until we get to the last object of inner.
            // Then it depends on the method's input flag argument.
            result = [result URLByAppendingPathComponent: next
                                             isDirectory: flag || (next != [inner lastObject])];
            
        }
    }
    return result;
}

-(NSArray*)siblingsWithError: (NSError**)error
{
    NSArray __block *siblings = [NSArray array];
    
    NSURL *uuidDir = [self URLByDeletingLastPathComponent];
    
    NSFileManager *fileMngr =
    [PNDocSupportNetController threadSafeFileManager];
    
    NSFileCoordinator* coordinator =
    [[NSFileCoordinator alloc] initWithFilePresenter:nil];
    [coordinator coordinateReadingItemAtURL:uuidDir
                                    options:NSFileCoordinatorReadingWithoutChanges
                                      error:error
                                 byAccessor:^(NSURL *coordinatedURL) {
                                     
                                     siblings = [fileMngr contentsOfDirectoryAtPath: [coordinatedURL path]
                                                                              error: error];
                                 }];

    return siblings;
}
@end
