//
//  PNAlertViewHelper.m
//  TaggedLocationsDemo
//
//  Created by DevGuy on 1/19/13.
//
//

#import "PNAlertViewHelper.h"

@implementation PNAlertViewHelper
//@synthesize invocationsForDismissButtonIndexes;
@synthesize mapButtonTitlesToInvocations;
//-(void)addDismissInvocation: (NSInvocation*)invocation
//{
//    NSMutableArray *tmp = [self.invocationsForDismissButtonIndexes mutableCopy];
//
//    if( nil == tmp ){
//        tmp = [NSMutableArray arrayWithCapacity:4];
//    }
//    [tmp addObject: invocation];
//    self.invocationsForDismissButtonIndexes = [tmp copy];
//}
+(NSMutableSet*)stash
{
    static NSMutableSet *mm_stash = nil;
    if( nil == mm_stash ){
        mm_stash = [[NSMutableSet alloc] initWithCapacity:8];
    }
    return mm_stash;
}
+(void)keep: (PNAlertViewHelper*)helper
{
    [[self stash] addObject: helper];
}
+(void)discard: (PNAlertViewHelper*)helper
{
    NSMutableSet *stash = [self stash];
    NSAssert( [stash containsObject: helper],
            @"Bogus sleazy inside-job retain/release");
    [stash removeObject: helper];
}

-(id)init
{
    self = [super init];
    if( self ){
        // This is sleazy, but:
        // I don't want every class that uses PNAlertViewHelper to retain an instance.
        // However, unless the instance is retained, the debugger tells me:
        // "*** -[PNAlertViewHelper alertView:didDismissWithButtonIndex:]: message sent to deallocated instance 0x78c1550"
        [[self class] keep: self];
    }
    return self;
}
-(void)setTarget: (NSObject*)target
        selector: (SEL)selector
  forButtonTitle: (NSString*)buttonTitle
{
    NSMethodSignature *mSig = [target methodSignatureForSelector: selector];
    NSInvocation *invocation = [NSInvocation invocationWithMethodSignature: mSig];
    invocation.target = target;
    invocation.selector = selector;

    [self setInvocation: invocation
         forButtonTitle: buttonTitle];
}
-(void)setInvocation: (NSInvocation*)invocation
      forButtonTitle: (NSString*)buttonTitle
{
    NSMutableDictionary *tmp = [self.mapButtonTitlesToInvocations mutableCopy];
    if( nil == tmp ){
        tmp = [NSMutableDictionary dictionaryWithCapacity:4];
    }
    [tmp setObject: invocation
            forKey: buttonTitle];
    self.mapButtonTitlesToInvocations = [tmp copy];
}
- (void)        alertView:(UIAlertView *)alertView
didDismissWithButtonIndex:(NSInteger)buttonIndex
{
    NSUInteger invocationsCount = self.mapButtonTitlesToInvocations.count;
    
    NSAssert(( invocationsCount > buttonIndex ),
             @"button index %d >= invocationsCount %d. Must have an invocation for every button.",
             buttonIndex,
             invocationsCount);
    
    NSString *buttonTitle = [alertView buttonTitleAtIndex: buttonIndex];
    
    NSInvocation *selected = [self.mapButtonTitlesToInvocations objectForKey: buttonTitle];
    
    NSAssert( [selected isKindOfClass:[NSInvocation class]],
             @"Bogus invocation: %@", [selected description]);
    
    [selected invoke];
    
    [[self class] discard: self];
    
}
@end
