//
//  DocumentController.h
//  TaggedLocationsDemo
//
//  Created by DevGuy on 3/26/12.
//  Copyright (c) 2012 NowPicture LLC. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "PNDocumentCreating.h"
#import "PNDocTokenMarking.h"
#import "PNTransitionDelegate.h"

@class PNDocToken;
@class RootViewController;
@class PNTransition;
//@class PNDocTokenPlace;

@interface DocumentController : UIViewController
    <UITableViewDelegate, 
    UITableViewDataSource,
    PNTransitionDelegate >
{
    NSOrderedSet *m_currentDeviceURLs; // available and assigned device urls
    NSOrderedSet *m_currentCloudURLs;  // available and assigned cloud urls
}
@property (strong, nonatomic) NSMutableArray* notificationObservers;

@property (readwrite, weak) RootViewController *rootViewController;
@property (readonly, weak) PNDocToken *docToken; // a convenience accessor

@property (nonatomic, weak) IBOutlet UITextField *docNameTextField;
@property (nonatomic, weak) IBOutlet UIButton *closeCreateDocButton; // Xcode is picky about names that start with "new".
@property (nonatomic, weak) IBOutlet UIButton *deleteDocButton;  
@property (nonatomic, weak) IBOutlet UIButton *openDocButton;

@property (nonatomic, weak) IBOutlet UITableView *tableView;

@property (readwrite, strong) PNTransition *activeTransition;

@end

