//
//  RootViewController+BadExamples.m
//  TaggedLocationsDemo
//
//  Created by DevGuy on 6/7/12.
//  Copyright (c) 2012 NowPicture LLC. All rights reserved.
//

#import "RootViewController+BadExamples.h"
#import "PNDocToken+FileOperations.h"
#import "PNDocToken+Managing.h"

@implementation RootViewController (BadExamples)
-(void)badExample1
{    
    // Don't call asynchronous operations sequentially as below.
    
    [self.docToken establishDocument];
    // [0] You shouldn't call this anyway.
    //     If you want a new document, use the API.
    //     You just forced a leak in the abstraction.
    
    // [1] self.docToken removes itself from its delegate (self), 
    //     and substitutes itself as docToken's delegate until completion
    //     (so it can manage the callbacks).
    //     Now, nil == self.docToken.
    
    [self.docToken closeDocument];
    // [2] But, before allocInitCommit returns its result in -acceptDocToken:,
    //     we now mistakenly try to launch another asynchronous workflow task.
}
-(void)badExample2
{
    // Never access your docToken.document unless the docToken is available.
    
    PNDocToken *myDocToken = self.docToken;
    // Never save a reference as above.
    // Always go through your doc token place, e.g.,
    //   [[self.docTokenPlace availableTokens] anyObject]
    
    [myDocToken closeDocument];
    // [1] myDocToken removes itself from its place.
    //     Now, nil == [[self.docTokenPlace availableTokens] anyObject].
    
    NSLog( @"Goodbye, %@", myDocToken.document.localizedName);
    // [2] But, before closeDocument returns its result in -acceptDocToken:,
    //     we try to get a property from the document.
    //     This may fail.
}
-(void)badExample3
{    
    // Here's another way to force a leak: mix static library API and raw Core Data API.
    
    [self.docToken establishDocument];
    
    [self.docToken.document closeWithCompletionHandler: nil];
}

@end
