//
//  TLDemoAppDelegate.m
//  TaggedLocationsDemo
//
//  Created by DevGuy on 2/15/12.
//  Copyright (c) 2012 NowPicture LLC. All rights reserved.
//

#import "TLDemoAppDelegate.h"
#import "TLDemoAppDelegate+StorageChoiceManaging.h"

#import "RootViewController.h"
#import "RootViewController+UuidTokenArchiving.h"

#import "PNDocSupportNetController.h"
#import "PNDocSupportNet.h"

#import "PNAlertViewHelper.h"

#import "PNSyncResources.h"
#import "PNQueryUpdate.h"

#import "PNURLToken.h"

#include <dispatch/dispatch.h>


@implementation TLDemoAppDelegate

@synthesize window = _window;
@dynamic applicationSupportDirectory;

//@synthesize navigationController;

@synthesize rootViewController;
@synthesize activeTransition;

@dynamic userDefaults;

#pragma mark Application Life-Cycle

-(NSUserDefaults*)userDefaults
{
    return [NSUserDefaults standardUserDefaults];
}

-(void)commonLaunch
{
    NSLog(@"-[%@ commonLaunch]", NSStringFromClass([self class]) );
    
    // Launch doc support:
    // Doc support has its own core data model and object graph.
    // The object graph includes:
    // [1] resources (wrapped as Petri Net tokens)
    // [2] collections of resources (Petri Net places)
    // [3] operations on resources (Petri Net transitions)
    
    NSURL *asd = [self applicationSupportDirectory];
    PNDocSupportNetController *dsnc = [PNDocSupportNetController sharedDocSupportNetController];
        
    [dsnc buildCoreDataStackInDirectory: asd
             appLevelTransitionDelegate: self];
    
    [self manageStorageChoice];
    
    UINavigationController *nc = (UINavigationController*)self.window.rootViewController;
        
    RootViewController *rvc = 
    [[nc viewControllers] objectAtIndex:0];
    
    self.rootViewController = rvc;
    
    UIDevice *device = [UIDevice currentDevice];
    
    [device beginGeneratingDeviceOrientationNotifications];

//    [self launchDiagnostics];
}


/**
 applicationWillTerminate: saves changes in the application's managed object context before the application terminates.
 */
- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     
     If your application supports background execution, 
     -applicationDidEnterBackground: is called instead of 
     -applicationWillTerminate: when the user quits.
     
     */

	/*
     "approximately five seconds"
     
     Discussion
     This method lets your application know that it is about to be terminated and purged from memory entirely. You should use this method to perform any final clean-up tasks for your application, such as freeing shared resources, saving user data, invalidating timers, and storing enough application state to reconstitute your application’s interface when it is relaunched. Your implementation of this method has approximately five seconds to perform any tasks and return. If the method does not return before time expires, the system may kill the process altogether.
     
     For applications that do not support background execution or are linked against iOS 3.x or earlier, this method is always called when the user quits the application. For applications that support background execution, this method is generally not called when the user quits the application because the application simply moves to the background in that case. However, this method may be called in situations where the application is running in the background (not suspended) and the system needs to terminate it for some reason.
     
     After calling this method, the application also posts a UIApplicationWillTerminateNotification notification to give interested objects a chance to respond to the transition.
     
     NSAssert( NO, @"Info.plist must specify that the app runs in the background. See the comments in -[PNDocToken closeDocumentInBackground]" );
     
     [self.docController closeandFinalizeDocumentInBackground];

     */
    
    
}

- (BOOL)           application:(UIApplication *)application 
 didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    NSLog(@"-[%@ application:didFinishLaunchingWithOptions:]", 
          NSStringFromClass([self class]) );
    
    NSLog(@" options = %@", [launchOptions description] );
    [self commonLaunch];
    return YES;//(nil != self.docController);
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
    NSLog(@"-[%@ applicationWillResignActive:]", NSStringFromClass([self class]) );
    
}


- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
    NSLog(@"-[%@ applicationWillEnterForeground:] ", NSStringFromClass([self class]) );
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
    NSLog(@"-[%@ applicationDidBecomeActive:] ", NSStringFromClass([self class]) );
    
    //[self launchDiagnostics];

}
- (NSUInteger)               application:(UIApplication *)application
 supportedInterfaceOrientationsForWindow:(UIWindow *)window
{
    return UIInterfaceOrientationMaskAllButUpsideDown;
}
#pragma mark Closing the document in the background, safely:
- (void)applicationDidEnterBackground:(UIApplication *)application
{
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
     */
    
    NSLog(@"-[%@ applicationDidEnterBackground:] End", NSStringFromClass([self class]) );
}


- (NSURL*)applicationSupportDirectory
{
    
    /**
     See:http://developer.apple.com/library/ios/#documentation/FileManagement/Conceptual/FileSystemProgrammingGUide/ManagingFIlesandDirectories/ManagingFIlesandDirectories.html
     
     Listing 6.1
     */
    if( nil != _applicationSupportDirectory ){
        return _applicationSupportDirectory;
    }
    
    NSFileManager*fileMgr = [PNDocSupportNetController threadSafeFileManager];
    
    // Find the application support directory in the home directory.
    NSArray* appSupportDirs = [fileMgr URLsForDirectory:NSApplicationSupportDirectory
                                        inDomains:NSUserDomainMask];
    if ([appSupportDirs count] > 0)
    {
        NSString* bundleID = [[NSBundle mainBundle] bundleIdentifier];
        // Append the bundle ID to the URL for the
        // Application Support directory
        _applicationSupportDirectory =
        [[appSupportDirs objectAtIndex:0] URLByAppendingPathComponent:bundleID];
        
        // If the directory does not exist, this method creates it.
        // This method call works in OS X 10.7 and later only.
        
        //PNDocSupportNetController *dscn = [PNDocSupportNetController sharedDocSupportNetController];
        [PNDocSupportNetController guaranteeDirectoryAtURL: _applicationSupportDirectory];
        
        // For the initial feasibility study,
        // we'll clean out _applicationSupportDirectory on every launch.
        // Later, when it works and we can trust it,
        // we can try to re-use whatever we find there.
        {
            NSDirectoryEnumerationOptions options =
            NSDirectoryEnumerationSkipsPackageDescendants | NSDirectoryEnumerationSkipsHiddenFiles;
            NSArray *propertyKeys =
            [NSArray arrayWithObjects:NSURLNameKey, NSURLIsDirectoryKey, NSURLTypeIdentifierKey, nil];
            
            NSDirectoryEnumerator *dirEnumerator = [fileMgr enumeratorAtURL: _applicationSupportDirectory
                                                 includingPropertiesForKeys: propertyKeys
                                                                    options: options
                                                               errorHandler: nil];
            
            NSFileCoordinator* coordinator =
            [[NSFileCoordinator alloc] initWithFilePresenter:nil];
            
            // Enumerate the dirEnumerator results
            for (NSURL *theURL in dirEnumerator) {
                
                [coordinator coordinateWritingItemAtURL:theURL
                                                options:NSFileCoordinatorWritingForDeleting
                                                  error:nil
                                             byAccessor:^(NSURL *coordinatedURL) {
                                                 
                                                 [fileMgr removeItemAtURL:coordinatedURL
                                                                    error:nil];
                                                 
                                             }];
                
            }

        }
    }
    return _applicationSupportDirectory;
}
#pragma mark TLDemoAppDelegate acts at the transition delegate for PNSyncResources and PNCloudUpdate

-(void)failNotSoGracefully
{
    abort();
}
-(void)postAlertFailedTransition: (PNTransition*)failedTransition
{
//    NSString *message =  NSLocalizedString( @"Unknown type",
//                                        @"-[TLDemoAppDelegate postAlertFailedTransition:] trouble type");
    
    NSString *errorDesc = [[failedTransition error] localizedDescription];
    
    NSString *transitionType =  NSStringFromClass([failedTransition class]);
    
//    if( [self.activeTransition isKindOfClass:[PNSyncResources class]] ){
//        transitionType =  NSLocalizedString( @"Local file system",
//                                     @"-[TLDemoAppDelegate postAlertFailedTransition:] Local file system trouble");
//    }
//    if( [self.activeTransition isKindOfClass:[PNQueryUpdate class]] ){
//        transitionType =  NSLocalizedString( @"Updating cloud documents",
//                                     @"-[TLDemoAppDelegate postAlertFailedTransition:] Trouble updating cloud documents");
//    }

    NSString *message =
    [NSString stringWithFormat: @"%@, %@",
       transitionType,
        errorDesc ];
    
    NSString *title =
    NSLocalizedString( @"Transition Failed",
                      @"-[TLDemoAppDelegate postAlertFailedTransition:] Alert Title");
    
    NSString *cancelButtonTitle =
    NSLocalizedString( @"Dang!",
                      @"-[TLDemoAppDelegate postAlertFailedTransition:] Quit Title: no recovery");
    
    
    PNAlertViewHelper *helper = [[PNAlertViewHelper alloc] init];
    
    [helper setTarget: self
             selector: @selector(failNotSoGracefully)
       forButtonTitle: cancelButtonTitle];
    
    
    UIAlertView *alert = [[UIAlertView alloc]
                          initWithTitle: title
                          message: message
                          delegate: helper
                          cancelButtonTitle: cancelButtonTitle
                          otherButtonTitles: nil];
    [alert show];
}
-(BOOL)shouldAttemptToRollbackTransition:(PNTransition *)transition
{
    return NO;
}
-(void)didFireTransition:(PNTransition *)transition
{

}
-(void)didFailTransition:(PNTransition *)transition
  rolledBackSuccessfully:(BOOL)success
{
    [self postAlertFailedTransition: transition];
}
@end


